<script setup lang="ts">
import ChangePasswordFormAdmin from '@/components/forms/ChangePasswordFormAdmin.vue'
import ChangeRoleForm from '@/components/forms/ChangeRoleForm.vue'
import EditUserForm from '@/components/forms/EditUserForm.vue'
import GitLabIntegrationFormAdmin from '@/components/forms/GitLabIntegration/GitLabIntegrationFormAdmin.vue'
import { ref } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore } from 'vuex'
//import SubscriberUserTemplateAdmin from '@/components/forms/SubscriberUserTemplateAdmin.vue'
import SubscriberUserForm from '@/components/forms/SubscriberUserForm.vue'
import UserSubscriptionForm from '@/components/forms/subscriptions/UserSubscriptionForm.vue'

const props = defineProps({
  userData: {
    type: Object,
    default: () => ({}),
  },
})

const route = useRoute()
const router = useRouter()
const store = useStore()
const user = ref({ role: '' })
const selectTab = ref(Number.parseInt(route.query.tab as string || '0', 10))

// Watcher for selectTab to react to changes
watch(selectTab, newTab => {
  console.info('INFO: selectTab', newTab)
  router.replace({ query: { ...route.query, tab: newTab.toString() } })
})

const numberedSteps = [
  {
    id: 0,
    title: 'General',
    component: 'EditUserForm',
    icon: 'tabler-user',
    disabled: false,
    subtitle: 'Manage general account settings and user information.',
  },
  {
    id: 1,
    title: 'Change password',
    component: 'ChangePasswordFormAdmin',
    icon: 'tabler-lock',
    disabled: false,
    subtitle: 'Update your password for enhanced security.',
  },
  {
    id: 2,
    title: 'Change role',
    component: 'ChangeRoleForm',
    icon: 'tabler-user-check',
    disabled: false,
    subtitle: 'Adjust user roles and permissions.',
  },
  {
    id: 3,
    title: 'Subscriber',
    component: 'SubscriberUserForm',
    icon: 'tabler-users',
    disabled: false,
    subtitle: 'View and manage subscriber details and statuses.',
  },
  {
    id: 4,
    title: 'Subscriptions',
    component: 'UserSubscriptionForm',
    icon: 'tabler-bell',
    disabled: false,
    subtitle: 'Manage subscriptions to services and notifications.',
  },
  {
    id: 5,
    title: 'GitLab integration',
    component: 'GitLabIntegrationFormAdmin',
    icon: 'tabler-brand-gitlab',
    disabled: false,
    subtitle: 'Configure and manage GitLab integration settings.',
  },
]
</script>

<template>
  <VRow>
    <VCol
      cols="12"
      md="4"
      :class="$vuetify.display.smAndDown ? 'border-b' : 'border-e'"
    >
      <VCardText>
        <!-- 👉 Stepper -->
        <AppStepper
          v-model:current-step="selectTab"
          direction="vertical"
          :items="numberedSteps"
          icon-size="24"
          class="stepper-icon-step-bg"
        />
      </VCardText>
    </VCol>
    <!-- 👉 stepper content -->
    <VCol
      cols="12"
      md="8"
    >
      <VCardText>
        <div>
          <VWindow
            v-model="selectTab"
            class="disable-tab-transition"
          >
            <!-- 👉 EditUserForm -->
            <VWindowItem>
              <EditUserForm
                v-if="selectTab === 0"
                :user-data="userData"
              />
            </VWindowItem>

            <!-- 👉 ChangePasswordFormAdmin -->
            <VWindowItem>
              <ChangePasswordFormAdmin
                v-if="selectTab === 1"
                :user-id="userData.id"
              />
            </VWindowItem>

            <!-- 👉 ChangeRoleForm -->
            <VWindowItem>
              <ChangeRoleForm
                v-if="selectTab === 2"
                :user-data="userData"
              />
            </VWindowItem>

            <!-- 👉 SubscriberUserForm -->
            <VWindowItem>
              <SubscriberUserForm
                v-if="selectTab === 3"
                :user-data="userData"
              />
            </VWindowItem>

            <!-- 👉 UserSubscriptionForm -->
            <VWindowItem>
              <UserSubscriptionForm
                v-if="selectTab === 4"
                :user-data="userData"
              />
            </VWindowItem>

            <!-- 👉 GitLabIntegrationFormAdmin -->
            <VWindowItem>
              <GitLabIntegrationFormAdmin
                v-if="selectTab === 5"
                :user-data="userData"
              />
            </VWindowItem>
          </VWindow>
        </div>
      </VCardText>
    </VCol>
  </VRow>
</template>
